#!/usr/bin/env bash
# Naver2RSS 1.0
# 네이버 뉴스 기사 목록 페이지를 긁어와서 RSS를 내놓는 스크립트
# 누가: 신재호 <netj@sparcs.kaist.ac.kr>
# 언제: 2004-01-03
# $Id: naver2rss.sh,v 1.1.1.1 2004/01/25 05:42:57 netj Exp $
# 
# 신문이나 TV 같은 언론을 RSS로 금방금방 받아보고 싶어서 뚝딱 만들었습니다. :)
# 혹시라도 네이버 페이지 생성 방식이 바뀌면 고쳐줘야할 부분들이 생길겁니다. :(
# 
# 셸 스크립트와 함께 마음대로 가져다 쓰십시오. 다만, 이 코드로 인해 생기는
# 문제에 대해서는 저에게 아무런 책임이 없습니다. 혹시라도 개선/제안할 내용이
# 있으면 제게도 알려주십시오. 뭐, 코드를 고쳐서 아주 재미있는 기능을 혼자만
# 쓰더라도 상관은 하지 않습니다.
# 
# 혹시라도 네이버 관계자 분들이 이 스크립트나 XSLT를 발견하신다면,
# "이런 변태 짓을 하게 만들었다니!"하면서 제발 경악하시고 어서 네이버에 RSS
# 인터페이스를 달아주세요. 다른 언론 사이트 관계자 분들도 마찬가지입니다.
#
# RSS가 무엇인지 궁금하시다면 http://www.feedvalidator.org/docs/rss2.html 를
# 읽어보십시오. RSS를 받아보는 프로그램은
# http://email.about.com/cs/rssfeedreaders/gr/ 또는
# http://www.ourpla.net/cgi-bin/pikie.cgi?RssReaders 를 보십시오.
#
#
# 이 스크립트를 사용하기 위해서는 bash, sed, iconv, libxslt의 xsltproc, tidy
# 등이 필요합니다. 잘 돌아가는 것을 확인하고 나면 cron에서 정기적으로 돌려주면
# 좋겠죠. :)
# */15 * * * *  cd 네이버2RSS_디렉토리 && exec ./naver2rss.sh >/dev/null

# 분야별 id와 제목들
sections=(top politics business community local world it sports entertainment life person editorial)
titles=("속보" "정치" "경제" "사회" "지역" "세계" "IT" "스포츠" "연예" "생활/문화" "인물" "칼럼")

for ((i=0; i<${#sections[@]}; i++)); do
    section="${sections[$i]}"
    echo $section
    wget --quiet --user-agent 'Naver2RSS/1.0' --output-document - \
	"http://news.naver.com/news_list.php?section=$section" \
     | iconv -f cp949 -t utf-8 2>/dev/null \
     | sed -ne'/<!--*기사리스트--*>/,/<!--*기사리스트--*>/{
	    s/&/&amp;/g
	    p
	}' \
     | tidy -clean -utf8 -asxml 2>/dev/null \
     >$section.html
    xsltproc --nonet 2>/dev/null \
	--param section_id "'$section'" \
	--param section "'${titles[$i]}'" \
	naver2rss.xsl $section.html \
     | xmllint --format --encode utf-8 - \
     >$section.rss
done
